models/Producto.php
<?php

namespace app\models;

use Yii;
use yii\helpers\ArrayHelper;
use yii\web\UploadedFile;

/**
 * This is the model class for table "producto".
 *
 * @property int $idProducto
 * @property string|null $nombre
 * @property string|null $descripcion
 * @property float|null $precio
 * @property float|null $descuento
 * @property int|null $oferta
 * @property int|null $unidadesStock
 * @property int|null $seccion
 * @property string $foto
 * @property int|null $destacado 
 *
 * @property Pedido[] $pedidos
 * @property Seccion $seccion0
 */
class Producto extends \yii\db\ActiveRecord
{

    public $archivo;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'producto';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['idProducto'], 'required'],
            [['idProducto', 'oferta', 'unidadesStock', 'seccion', 'destacado'], 'integer'],
            [['precio'], 'number'],
            [['descuento'], 'number', 'min' => 0, 'max' => 100],
            [['nombre', 'foto'], 'string', 'max' => 100],
            [['descripcion'], 'string', 'max' => 800],
            [['archivo'], 'file',  'skipOnEmpty' => true, 'mimeTypes' => 'image/*'],
            [['idProducto'], 'unique'],
            [['seccion'], 'exist', 'skipOnError' => true, 'targetClass' => Seccion::class, 'targetAttribute' => ['seccion' => 'idSeccion']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'idProducto' => 'ID producto',
            'nombre' => 'Nombre del producto',
            'descripcion' => 'Descripción',
            'precio' => 'Precio',
            'descuento' => 'Descuento',
            'oferta' => 'Oferta',
            'unidadesStock' => 'Unidades en stock',
            'seccion' => 'Sección',
            'foto' => 'Foto',
            'destacado' => 'Destacado',
        ];
    }

    /**
     * Gets query for [[Pedidos]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getPedidos()
    {
        return $this->hasMany(Pedido::class, ['idProducto' => 'idProducto']);
    }

    /**
     * Gets query for [[Seccion0]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getSeccion0()
    {
        return $this->hasOne(Seccion::class, ['idSeccion' => 'seccion']);
    }

    public function getSecciones()
    {
        $secciones = Seccion::find()->all();
        return ArrayHelper::map($secciones, 'idSeccion', 'nombre');
    }

    public function getProductoconseccion()
    {
        return $this->nombre . " ({$this->seccion0->nombre})";
    }


    public function beforeValidate(): bool
    {
        // Comprobamos si has seleccionado una foto 
        if (isset($this->archivo)) {
            $this->archivo = UploadedFile::getInstance($this, "archivo");
        }
        return true; // este metodo te pide que devuelvas true. Si no devuelves true no hace nada
    }

    public function afterValidate(): bool
    {
        // Volvemos a comprobar si se ha subido una foto
        if (isset($this->archivo)) {
            $this->subirArchivo();
            $this->foto = $this->idProducto . '_' . $this->archivo->name; // Al campo foto le guardamos el nombre de la foto
        }
        return true; // este metodo te pide que devuelvas true. Si no devuelves true no hace nada
    }


    public function subirArchivo(): bool
    {
        $this->archivo->saveAs('imgs/productos/' . $this->idProducto . '_' . $this->archivo->name, false);  // false, si la foto existe, no sube la nueva para no destruir la que está
        return true;
    }

    // Disparador que se ejecuta después de eliminar un registro
    public function afterDelete()
    {
        // Elimino la imagen de web/imgs/productos
        if ($this->foto != null && file_exists(Yii::getAlias("@webroot") . '/imgs/productos/' . $this->foto)) {
            unlink('imgs/productos/' . $this->foto);
        }
        return true;
    }
    /**
     * afterSave 
     * Este método se ejecuta después de guardar el registro en la BBDD
     * 
     * @param  mixed $insert este argumento es true si se está insertando un registro y false si es una actualización
     * @param  array $atributosAnteriores Array con todos los datos de la tabla antes de actualizar
     * @return void
     */
    public function afterSave($insert, $atributosAnteriores)
    {
        // Si estoy actualizando datos
        if (!$insert) {
            // Si el prodcuto tenía ya una foto y hemos adjuntado una nueva, elimina la vieja
            if (isset($this->archivo) && isset($atributosAnteriores['foto'])) {
                unlink('imgs/productos/' . $atributosAnteriores['foto']);
            }
        }
    }

    public function getPrecioeuros()
    {
        return $this->precio . " €";
    }

    public function getPrecioRebajado()
    {
        if ($this->oferta && isset($this->descuento)) {
            return round($this->precio - ($this->precio * $this->descuento / 100), 2);
        } else {
            return $this->precio;
        }
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Cliente;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\Pedido;
use app\models\Producto;
use app\models\Seccion;
use app\models\Usuario;
use yii\data\ActiveDataProvider;
use yii\web\NotFoundHttpException;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {

        $secciones = Seccion::find()->all();


        return $this->render('index', [
            'secciones' => $secciones
        ]);
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    public function actionSecciones()
    {
        $secciones = Seccion::find()->all();

        return $this->render('secciones', [
            'secciones' => $secciones
        ]);
    }

    public function actionSeccion($id)
    {
        $productos = Producto::find()->where(['seccion' => $id])->andWhere(['destacado' => 1])->all();
        $secciones = Seccion::find()->all();

        return $this->render('seccion', [
            'productos' => $productos,
            'secciones' => $secciones
        ]);
    }


    public function actionProductos($id)
    {
        $datos = Producto::find()->where(['seccion' => $id])->all();

        $dato = Producto::find()->where(['seccion' => $id])->one();

        return $this->render("productos", [
            "datos" => $datos,
            "titulo" => "Productos de la sección: " . $dato->seccion0->nombre,

        ]);
    }

    public function actionVerproducto($idProducto)
    {
        $consulta = Producto::find()->where(['idProducto' => $idProducto]);

        $dato = $consulta->one();

        return $this->render('verproducto', [
            'dato' => $dato,
        ]);
    }

    public function actionOfertas()
    {
        $secciones = Seccion::find()->all();

        return $this->render('ofertasListview', [
            'secciones' => $secciones
        ]);
    }

    // Accion de registro
    public function actionRegistro()
    {
        $model = new Usuario();

        if (Yii::$app->request->isPost) {
            $postData = Yii::$app->request->post();

            $model->load($postData);

            if ($model->validate() && $model->save()) {

                return $this->redirect(['site/success']);
            }
        }

        return $this->render('registro', ['model' => $model]);
    }

    // Accion cuando el usuario se ha registrado correctamente
    public function actionSuccess()
    {
        return $this->render('success');
    }

    // Accion para hacer un pedido
    public function actionHacerpedido($idProducto, $idUsuario = 0)
    {
        // Si el usuario no esta logeado => que se logee
        if (Yii::$app->user->isGuest || $idUsuario == null) {
            return $this->redirect(['site/login']);
        }

        // Si es la primera vez que el usuario hace un pedido, tenemos que crear un registro en la tabla cliente

        $cliente = Cliente::findOne(['usuario' => $idUsuario]);
        if ($cliente  == null) {
            // return $this->redirect(['/site/crearcliente', 'idCliente' => $idUsuario]);
            $user = Usuario::findOne($idUsuario);
            $cliente = new Cliente();
            $cliente->idCliente = $user->id;
            $cliente->nombre = $user->nombre;
            $cliente->correo = $user->username;
            $cliente->usuario = $user->id;
            $cliente->save();
        }

        // Para hacer un pedido se necesita que el cliente tenga direccion y telefono
        if ($cliente->direccion == "" || $cliente->direccion == null || $cliente->telefono == "" || $cliente->telefono == "") {
            Yii::$app->session->setFlash('error', 'Necesitamos tu dirección y tu teléfono');
            return $this->redirect(['cuenta', 'idUsuario' => $cliente->usuario]);
        }

        // Creamos un modelo vacio para pedidos
        $model = new Pedido();
        $producto = Producto::findOne($idProducto);
        $cliente = Cliente::findOne($idUsuario);

        $model->idCliente = $cliente->idCliente;
        $model->idProducto = $producto->idProducto;

        if ($this->request->isPost) {
            // Comprobamos si la cantidad solicitada es menor o igual que las unidades que se tiene en stock
            if ($model->load($this->request->post()) && $model->save() && $model->cantidad <= $producto->unidadesStock) {

                // Si se hace el pedido, las unidades en stock se modifican
                $producto->unidadesStock -= $model->cantidad;
                $producto->save();

                return $this->redirect(['pedido', 'idCliente' => $cliente->idCliente]);
                // Si la cantidad supera las unidades en stock, se muestra un mensaje de error
            } else {
                Yii::$app->session->setFlash('error', 'No disponemos de tantas unidades. Tenemos ' . $producto->unidadesStock . ' unidades');
                $model->delete();
            }
        } else {
            $model->loadDefaultValues();
        }

        // cargamos el formulario para hacer un pedido
        return $this->render('hacerpedido', [
            'model' => $model,
            "cliente" => $cliente,
            "producto" => $producto,
        ]);
    }

    // Accion cuando el usuario ha realizado un pedido correctamente
    public function actionPedido($idCliente)
    {
        return $this->render('pedido', [
            'idCliente' => $idCliente
        ]);
    }

    public function actionVerpedidos($idCliente)
    {

        $dataProvider = new ActiveDataProvider([
            'query' => Pedido::find()->where(['idCliente' => $idCliente]),

            'pagination' => [
                'pageSize' => 10
            ],
            /*
            'sort' => [
                'defaultOrder' => [
                    'idPedido' => SORT_DESC,
                ]
            ],
            */

        ]);

        return $this->render('verpedidos', [
            'dataProvider' => $dataProvider
        ]);
    }

    public function actionCuenta($idUsuario)
    {
        // Si el usuario no esta logeado => que se logee
        if (Yii::$app->user->isGuest) {
            return $this->redirect(['site/login']);
        }

        // Si es la primera vez que el usuario hace un pedido, tenemos que crear un registro en la tabla cliente
        if ($cliente = Cliente::findOne(['idCliente' => $idUsuario]) == null) {
            // return $this->redirect(['/site/crearcliente', 'idCliente' => $idUsuario]);
            $user = Usuario::findOne($idUsuario);
            $cliente = new Cliente();
            $cliente->idCliente = $user->id;
            $cliente->nombre = $user->nombre;
            $cliente->correo = $user->username;
            $cliente->usuario = $user->id;
            $cliente->save();
        }

        $model = Cliente::findOne($idUsuario);

        return $this->render('cuenta', [
            "model" => $model,
        ]);
    }


    // ACTUALIZAR DATOS DEL USUARIO
    public function actionActualizarcuenta($idCliente)
    {
        // Si el usuario no esta logeado => que se logee
        if (Yii::$app->user->isGuest) {
            return $this->redirect(['site/login']);
        }

        $model = Cliente::findOne(['idCliente' => $idCliente]);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            $usuario = Usuario::findOne(['id' => $model->usuario]);
            // UPDATE
            // Si se cambia el correo o el nombre del cliente, se la cambiamos también a la tabla usuario 
            $connection = Yii::$app->db;
            $connection->createCommand()->update('usuario', ['nombre' => $model->nombre, 'username' => $model->correo], ['id' => $usuario->id])->execute();

            return $this->redirect(['cuenta', 'idUsuario' => $model->usuario]);
        }

        return $this->render('actualizarcuenta', [
            'model' => $model,
        ]);
    }

    // Cancelar un pedido
    public function actionCancelarpedido($idPedido)
    {
        $pedido = Pedido::findOne(['idPedido' => $idPedido]);

        $producto = Producto::findOne(['idProducto' => $pedido->idProducto]);

        // Comparamos la fecha de envio con la fecha actual

views/site/_formCuenta.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

?>


<div class="">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'apellidos')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'correo')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'direccion')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'poblacion')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'codigoPostal')->input('number') ?>

    <?= $form->field($model, 'telefono')->input('number') ?>

    <?= $form->field($model, 'telefono2')->input('number') ?>

    <div class="form-group">
        <?= Html::submitButton('Guardar cambios', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/site/_ofertas.php
<?php

use yii\helpers\Html;
?>
<tr>
    <td class="nombre"> <?= $model->nombre ?></td>
    <td> <del><?= $model->precioEuros ?></del></td>
    <td> <?= $model->precioRebajado . ' €' ?></td>
    <td class="imagen"> <?= Html::img("@web/imgs/productos/" . $model->foto, ['style' => 'width:200px;height:200px']) ?></td>
    <td>
        <p>
            <?= Html::a('Ver detalles del producto', ['site/verproducto', 'idProducto' => $model->idProducto], ['class' => 'btn btn-success']) ?>
        </p>
        <p>
            <?= Html::a('Comprar <i class="fas fa-cart-plus"></i>', ['site/hacerpedido', 'idProducto' => $model->idProducto, 'idUsuario' => Yii::$app->user->id], ['class' => 'btn btn-info text-dark', 'style' => 'width:']) ?>
        </p>
    </td>
</tr>

views/site/_productos.php
<?php

use yii\helpers\Html;

?>
<div class="productos">

    <h3><?= $dato['nombre'] ?></h3>

    <?php
    if ($dato['oferta']) {

    ?>
        <h3>Precio: &nbsp;<span style="color: red;"><del><?= $dato['precioeuros'] ?></del></span> <span style="margin-left: 10px;"><?= $dato['precioRebajado'] ?> €</span></h3>
    <?php
    } else {
    ?>
        <h3>Precio: &nbsp;<span><?= $dato['precioeuros'] ?></span> </h3>
    <?php
    }

    ?>
    <p>
        <?php
        if (isset($dato['foto'])) {
            echo Html::img("@web/imgs/productos/{$dato['foto']}", ['style' => 'width:200px;height: 200px', 'class' => 'img-thumbnail']);
        } else {
            echo  Html::img("@web/imgs/notfound.jpg", ['style' => 'width:200px;height: 200px', 'class' => 'img-thumbnail']);
        }
        ?>
    </p>

    <?= Html::a('Más detalles', ['site/verproducto', 'idProducto' => $dato->idProducto], ['class' => 'botonDetalles']) ?>

</div>

views/site/actualizarcuenta.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Pedido $model */

$this->title = 'Mi cuenta';
$this->params['breadcrumbs'][] = ['label' => 'Cuenta', 'url' => ['cuenta']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="pedido-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_formCuenta', [
        "model" => $model,
    ]) ?>

</div>

views/site/cuenta.php
<?php

use yii\helpers\Html;

$this->title = 'Mi cuenta';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="cuenta">

    <h1><?= Html::encode($this->title) ?></h1>

    <div>
        <span> Nombre:</span> <?= $model->nombre ?>
    </div>
    <div>
        <span> Apellidos:</span> <?= $model->apellidos ?>
    </div>
    <div>
        <span>Correo:</span> <?= $model->correo ?>
    </div>
    <div>
        <span> Dirección:</span> <?= $model->direccion ?>
    </div>
    <div>
        <span> Población:</span> <?= $model->poblacion ?>
    </div>
    <div>
        <span> Código postal:</span> <?= $model->codigoPostal ?>
    </div>
    <div>
        <span> Teléfono móvil:</span> <?= $model->telefono ?>
    </div>
    <div>
        <span> Teléfono:</span> <?= $model->telefono2 ?>
    </div>

    <div>
        <?= Html::a('Actualizar datos', ['site/actualizarcuenta', 'idCliente' => $model->idCliente], ['class' => 'btn btn-success']) ?>
    </div>



</div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */

use app\models\Producto;
use yii\bootstrap5\Carousel;
use yii\helpers\Html;

?>

<div class="contenedor">

    <?php
    include '_menuSecciones.php';
    foreach ($secciones as $seccion) {
    ?>
        <h2> Productos <?= $seccion['nombre'] ?>:</h2>

        <div class="carousel">
            <?php

            //$datos = Producto::find()->where(['oferta' => 1, 'seccion' => $seccion])->all();


            // carousel
            $items = [];
            foreach ($seccion->productosDestacado as $producto) {
                $items[] = [
                    "content" => Html::img("@web/imgs/productos/" . $producto->foto, ['class' => 'd-block m-auto', 'style' => 'width:250px;height:300px']),
                    "caption" => mostrarPrecios($producto),
                    "options" => []
                ];
            }
            echo Carousel::widget([
                "items" => $items,
                "options" => [
                    "class" => 'carousel-dark col-3 '
                ],
            ]);
            ?>

        <?php
    }
        ?>
        </div>

</div>

<?php
function mostrarPrecios($producto)
{
    if ($producto->oferta = true && $producto->descuento != null && $producto->descuento != 0) {
        return Html::a("<div class='bg-secondary text-white fit'> <span>{$producto->nombre}</span> <span style='color:black;font-size:0.8em'><del>{$producto->precioEuros}</del></span> <span>{$producto->precioRebajado} €</span> </div>", ['site/verproducto', 'idProducto' => $producto->idProducto],);
    } else {
        return  Html::a("<div class='bg-secondary text-white fit'> <span>{$producto->nombre}</span> <span style='color:black;'>{$producto->precioEuros}</span> </div>", ['site/verproducto', 'idProducto' => $producto->idProducto],);
    }
}

views/site/ofertas.php
<?php

use yii\helpers\Html;

foreach ($secciones as $seccion) {
?>
    <h2 class="oferta">Productos <?= $seccion->nombre ?> en oferta</h2>
    <table class="tablaOfertas">

        <tr>
            <td>Nombre</td>
            <td>Precio</td>
            <td>Precio rebajado</td>
            <td>Foto</td>
            <td></td>
        </tr>
        <?php
        foreach ($seccion->productosOferta as $producto) {
        ?>

            <tr>
                <td class="nombre"> <?= $producto->nombre ?></td>
                <td> <del><?= $producto->precioEuros ?></del></td>
                <td> <?= $producto->precioRebajado . ' €' ?></td>
                <td class="imagen"> <?= Html::img("@web/imgs/productos/" . $producto->foto, ['style' => 'width:200px;height:200px']) ?></td>
                <td> <?= Html::a('Ver detalles del producto', ['site/verproducto', 'idProducto' => $producto->idProducto], ['class' => 'botonDetalles']) ?></td>
            </tr>
        <?php
        }
        ?>
    </table>

<?php


}

views/site/pedido.php
<?php

use yii\helpers\Html;

$this->title = 'Pedido realizado correctamente';
$this->params['breadcrumbs'][] = $this->title;
?>

<h1><?= Html::encode($this->title) ?></h1>

<?php
(!empty($nombre)) ? '<p> Hola' . Html::encode($nombre) . '</p>' : '';
?>

<p>Tu pedido se ha realizado correctamente</p>

<?= Html::a('Ver mis pedidos', ['site/verpedidos', 'idCliente' => $idCliente], ['class' => 'btn btn-primary']) ?>

views/site/productos.php
<div class="contenedor">

    <h2> <?= isset($titulo) ? $titulo : "Productos" ?></h2>
    <div class="tablaProductos">
        <?php

        foreach ($datos as $dato) {
        ?>

        <?php
            echo $this->render('_productos', [
                'dato' => $dato,
            ]);
        }

        ?>
    </div>
</div>

views/site/registro.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

$this->title = 'Registro';
$this->params['breadcrumbs'][] = $this->title;
?>

<h1><?= Html::encode($this->title) ?></h1>

<?php $form = ActiveForm::begin(); ?>

<?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

<?= $form->field($model, 'username')->input('email') ?>

<?= $form->field($model, 'password')->passwordInput(['maxlength' => true]) ?>

<?php
if ($model->isAdmin = null) {
    $model->isAdmin = 0;
}
?>

<div class="form-group">
    <?= Html::submitButton('Registrarse', ['class' => 'btn btn-primary']) ?>
</div>

<?php ActiveForm::end(); ?>

views/site/secciones.php
<?php

use yii\helpers\Html;

?>
<div class="row">
    <?php
    foreach ($secciones as $dato) {
    ?>
        <div class="col-6 mb-3">
            <div class="card cartas">
                <div class="card-body">

                    <h5 class="card-title"><?= $dato->nombre ?></h5>
                    <?= Html::a('Ver productos', ['site/productos', 'id' => $dato->idSeccion], ['class' => 'btn btn-primary']) ?>

                </div>
            </div>
        </div>
    <?php
    }
    ?>
</div>

views/site/verProducto.php
<?php

use yii\helpers\Html;
?>

<h2 style="text-align: center;margin:25px"> <?= $dato->nombre ?></h2>
<div class="fotoVerProducto" style="float:right;"><?= Html::img("@web/imgs/productos/{$dato->foto}", ['style' => 'width:320px;height:320px', 'class' => 'img-fluid']) ?></div>

<div class="contenedorTablaProducto">
    <table class="tablaProducto">
        <tbody>
            <tr>
                <td>Descripción</td>
                <td><?= $dato->descripcion ?></td>
            </tr>
            <tr>
                <td>Precio</td>
                <td><?= $dato->precio ?> €</td>
            </tr>
            <tr>
                <td>Descuento</td>
                <td><?php

                    echo ($dato->descuento != 0 && $dato->descuento != null) ?  $dato->descuento . ' %' : '';
                    ?>
                </td>
            </tr>
            <tr>
                <td>Precio rebajado</td>
                <td><?= $dato->precioRebajado ?> €</td>
            </tr>
            <tr>
                <td>Unidades en Stock</td>
                <td> <?= $dato->unidadesStock ?></td>
            </tr>
            <tr>
                <td>Sección</td>
                <td> <?= $dato->seccion0->nombre ?></td>
            </tr>
            <tr>
                <td colspan="2">
                    <?= Html::a('Comprar <i class="fas fa-cart-plus"></i>', ['site/hacerpedido', 'idProducto' => $dato->idProducto, 'idUsuario' => Yii::$app->user->id], ['class' => 'btn btn-info text-dark', 'style' => 'width:']) ?>
                </td>
            </tr>
        </tbody>

    </table>
</div>

views/site/verpedidos.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;

echo GridView::widget([
    'dataProvider' => $dataProvider,
    'columns' => [
        ['class' => 'yii\grid\SerialColumn'],
        [
            'attribute' => 'idProducto',
            'value' => function ($model) {
                return $model->idProducto0->productoconseccion;
            }
        ],
        'cantidad',
        [
            'attribute' => 'Precio/unidad',
            'value' => function ($model) {
                return $model->idProducto0->precioEuros;
            }
        ],
        [
            'attribute' => 'Precio total',
            'value' => function ($model) {
                return $model->idProducto0->precio * $model->cantidad . ' €';
            }
        ],
        [
            'attribute' => 'fechaPedido',
            'value' => function ($model) {
                return $model->fechaEspana($model->fechaPedido);
            }
        ],
        //'fechaEnvio',
        [
            'attribute' => 'fechaEnvio',
            'value' => function ($model) {
                return $model->fechaEspana($model->fechaEnvio);
            }
        ],
        [
            'attribute' => '',
            'format' => 'raw',
            'value' => function ($model) {
                return Html::a('Eliminar pedido', ['cancelarpedido', 'idPedido' => $model->idPedido], [
                    'class' => 'btn btn-danger',
                    'data' => [
                        'confirm' => '¿Estás seguro que quieres eliminar el pedido?',
                        'method' => 'post',
                    ],
                ]);
            }
        ]

    ],
]);